package sparqlstatement;

import java.util.ArrayList;
import sparqlinterpreter.Interpreter;
import triskelTable.Table;
import triskeloperationtree.OperationTree;
import triskeloperationtree.TableNode;

public class Statement {
    
    public Statement() {
    }
    
    public Table executeQuery(String query){
        Interpreter interpreterSPARQL = new Interpreter();
        ArrayList<String> selectVariables;
        interpreterSPARQL.executeQuery(query);
        OperationTree operationTree = interpreterSPARQL.getOperationTree();
        selectVariables = interpreterSPARQL.getSelectVariables();
        /*
            Integración con el QueryPlayer
        */
        Table result = ((TableNode) operationTree.getRoot()).getTable();
        return result.select((String[]) selectVariables.toArray());
    }
    
    
    

   
}
