package sparqlinterpreter;

import sparqltree.SparqlSemanticTree;
import triskeloperationtree.FunctionNode;

class FunctionBuilder {
    
    SparqlSemanticTree semanticTree;
    int index;
    
    public FunctionBuilder(SparqlSemanticTree semanticTree) {
        this.semanticTree = semanticTree;
    }

    void getFunctionChilds(FunctionNode joinNode, int childsStartIndex) {
        PatternHandler patternHandler = new PatternHandler(semanticTree);
        index = childsStartIndex;
        if (semanticTree.getValue(index).equals("{"))index++;
        while (!semanticTree.getValue(index).equals("}")) {
            if (semanticTree.isTripletMember(index)) {
                index = patternHandler.getPatterns(index, joinNode);
            }
            if (semanticTree.getValue(index).equals(".")) {
                index++;
            }
        }
    }

    public int getIndex() {
        return index;
    }
    
}
